---
layout: layouts/test.njk
class: 3BHET
group: A
subject: CPE
date: 2022-06-15
points: [4, 10, 5, 5]
grading: "Benotung: >=21: 1, >=18: 2, >=15: 3, >=12: 4, <12: 5"
---

<ol>
  <li>Markiere, welche der folgenden Aussagen wahr bzw. falsch sind.<br />
  0-4 korrekt: 0 Punkte, 5 korrekt: 1 Punkt, 6 korrekt: 2 Punkte,
  7 korrekt: 3 Punkte, 8 korrekt: 4 Punkte.
  <table class="true-false">
      <tr>
        <th>Aussage</th>
        <th>Wahr</th>
        <th>Falsch</th>
      </tr>
      {% yes_no_question 'Ein <code>struct</code> in C ist ein Pointer zu
        einem Array.', 'no' %}
      {% yes_no_question 'Ein <code>struct</code> darf Pointer beinhalten.',
        'yes' %}
      {% yes_no_question 'Ein Pointer kann auf einen
        anderen Pointer zeigen.', 'yes' %}
      {% yes_no_question 'Header Dateien werden durch den Assembler mit den
        C Dateien verbunden.', 'no' %}
      {% yes_no_question '<code>malloc(.)</code> initialisiert den reservierten
        Speicher mit Nullen.', 'no' %}
      {% yes_no_question 'Ein Pointer zeigt auf eine Adresse im Hauptspeicher
        (RAM) des Computers.', 'yes' %}
      {% yes_no_question 'Das Aufteilen eines Programms auf mehrere
        Sourcecode Dateien verlängert die Kompilierzeit drastisch.', 'no' %}
      {% yes_no_question 'Der C Compiler übersetzt C Code in Assembly.',
        'yes' %}
    </table>
  </li>


  <li>Welcher Text wird durch die folgenden Code Snippets in der
    C-Programmiersprache auf Standard Output
    (Terminal) geschrieben? Schreibe den genauen Output des Snippets.
    Die Snippets werden als Teil von <code>int main()</code> ausgeführt und
    alle notwendigen <code>#include</code>s sind vorhanden.
    Wenn das Snippet nicht kompilierbar ist oder zu einem Absturz führen würde,
    so ist das Wort “ERROR” als Antwort zu geben.
    Erzeugt das Snippet keinen Output (wenn beispielsweise kein
    <code>printf</code> oder dergleichen aufgerufen wird), so ist "-" als
    richtige Antwort zu verwenden.
    <ol>
      <li>
{% highlight "c" %}
int a = 3;
int* ptr = &a;
*ptr += 4;
printf("%d\n", a);
{% endhighlight %}
{% answer %}
7
{% endanswer %}
      </li>

      <li>
{% highlight "c" %}
int a = 3;
int* ptr = &a;
int** p = &ptr;
**p += **p;
{% endhighlight %}
{% answer %}
-
{% endanswer %}
      </li>

      <li>
{% highlight "c" %}
int array[] = {3, 3, 3, 3, 3};
int* array_ptr = array;
int count = sizeof(array) / sizeof(int);
int value = 0;
while (count--) {
  value += *array_ptr++;
}
printf("%d\n", value);
{% endhighlight %}
{% answer %}
15
{% endanswer %}
      </li>

      <li>
{% highlight "c" %}
char name[] = "Pat";
char* name_ptr = name;
while (*name_ptr) {  // string ends with the `\0` character
  printf("%c", *name_ptr);
  name_ptr++;
}
printf("\n");
{% endhighlight %}
{% answer %}
Pat
{% endanswer %}

      <li>
{% highlight "c" %}
typedef struct {int year; int month; int day;} IsoDate;
IsoDate date = {2022, 2, 1};
printf("%s\n", date);
{% endhighlight %}
{% answer %}
ERROR
{% endanswer %}
      </li>

    </ol>
  </li>


  <li>Schreibe eine Funktion
    <code>int* range(int start, int stop);</code> welche einen Pointer zu einem
    Array mit aufsteigenden Zahlen zurück gibt. Der erste Wert des Arrays ist
    <code>start</code>, der letzte <code>stop - 1</code>. Die Anzahl der
    Elemente ist dementsprechend <code>stop - start</code>. Zum Beispiel gibt
    der Aufruf <code>range(3, 8)</code> einen Pointer zu folgendem Array
    zurück: <code>{3, 4, 5, 6, 7}</code>.
{% answer %}
    <div class="grading">
      0.5 Punkt den korrekten Funktionsnamen und die korrekte Signatur<br />
      1 Punkt für das Berechnen der richtigen Menge an Speicher<br />
      1 Punkt für das Reservieren des Speichers<br />
      1 Punkt für die korrekte Schleife zum Initialisieren<br />
      1 Punkt für das Initialisieren mit den richtigen Werten<br />
      0.5 Punkt für die Rückgabe des Arrays<br />
    </div>
{% highlight "c" %}
int* range(int start, int stop) {
  int* array = (int*) malloc((stop - start) * sizeof(int));
  for (int i = 0; i < stop - start; ++i) {
    array[i] = start + i;
  }
  return array;
}
{% endhighlight %}
{% endanswer %}
  </li>

  <li>Erstelle einen Typen <code>Resistor</code>, welcher folgende
    Eigenschaften speichert: <code>unsigned int resistance</code>,
    <code>unsigned int max_voltage</code>,
    <code>float tolerance</code> und
    <code>char type[50]</code>. Reserviere Speicher auf dem Free Store für
    einen neuen <code>Resistor</code> und speichere einen Pointer darauf in der
    Variable <code>Resistor* r</code>.

{% answer %}
    <div class="grading">
      1 Punkt für den Typedef<br />
      1 Punkt für die Deklaration des Structs<br />
      2 Punkte für die 4 Felder<br />
      1 Punkt für Variable mit Pointer auf reservierten Resistor
    </div>
{% highlight "c" %}
typedef struct resistor Resistor;
struct resistor {
  char type[50];
  unsigned int resistance;
  float tolerance;
  unsigned int max_voltage;
};
Resistor* r = (Resistor*) malloc(sizeof(Resistor));
{% endhighlight %}
{% endanswer %}
  </li>

</ol>
